<template>
  <slot :user-typing-message="userTypingMessage" />
</template>

<script setup lang="ts">
import { PropType } from 'vue';
import { storeToRefs } from 'pinia';
import computedEager from '@new-jira-clone/ui/src/composables/utils/useComputedEager';
import { IChat } from '@/shared';
import { useTypingMessages } from '../model/useTypingMessage';

const props = defineProps({
  chat: {
    type: Object as PropType<IChat>,
    required: true,
  },
});

const { getTypingMessages } = storeToRefs(useTypingMessages());

const userTypingMessage = computedEager(() => {
  const typeMessage = getTypingMessages.value.find(
    (typingMessage) => typingMessage.chat.id === props.chat.id,
  );

  if (!typeMessage) return null;

  if ('interlocutor' in props.chat) {
    return props.chat.interlocutor;
  }

  return props.chat.members.find((member) => member.id === typeMessage.user.id);
});
</script>
